	device	ZXSPECTRUM128	

	include	dev\ts-ports.asm
	include	dev\ts-macros.asm

	org	25000

start	di
	ld	sp,24999
;---------------------------------	
		
	call	init_pal

	set_tile0_page 160
	set_tile_map_page 150

	call	fill_tile_0
	call	bit_copy
	
	xor	a
	ld	bc,T0XOffsL
	out	(c),a
	xor	a
	ld	bc,T0XOffsH
	out	(c),a
	xor	a
	ld	bc,T0YOffsL
	out	(c),a
	xor	a
	ld	bc,T0YOffsH
	out	(c),a

	xor	a
	ld	bc,T1XOffsL
	out	(c),a
	xor	a
	ld	bc,T1XOffsH
	out	(c),a
	xor	a
	ld	bc,T1YOffsL
	out	(c),a
	xor	a
	ld	bc,T1YOffsH
	out	(c),a

	ld	hl,0
	ld	bc,GYOffsL
	out	(c),l
	ld	bc,GYOffsH
	out	(c),h
	ld	bc,GXOffsL
	out	(c),l
	ld	bc,GXOffsH
	out	(c),h

	call	clear_page

	
	ld	bc,Page3
	ld	a,128
	out	(c),a	

	call	set_im2
	
	ld	a,0
	ld	(music+10),a
	call	music
	call	set_color
	call	create_screen
;-------------------------------- init modes ----
	ld	bc,VConfig
	ld	a,res36x28x16
	out	(c),a

	ld	bc,TSConfig
	ld	a,%00101100
	out	(c),a

	ld	bc,VPage
	ld	a,128
	out	(c),a

	ld	bc,SysConfig
	ld	a,%00000110
	out	(c),a

	ld	bc,PalSel
	ld	a,%00110000
	out	(c),a
;---------------------------------  ------
	ei	
stop	jr	stop


;----------------------------------------------------------------------------------------
;    -       
;            n 
; 
;----------------------------------------------------------------------------------------
im_proc_2	di
		push	af
		push	hl
		push	de
		push	bc

		
		ld	a,(line_size)
		ld	l,a
		ld	h,0
		ld	bc,GYOffsL
		out	(c),l
		ld	bc,GYOffsH
		out	(c),h

		ld	hl,(int_line)
		inc	hl
		ld	(int_line),hl

		ld	a,h
		cp	1
		jr	nz,impr2
		ld	a,l
		cp	64
		jr	nz,impr2

		ld	hl,im_proc_1
		ld	(#beff),hl
		ld	hl,0
		ld	bc,GYOffsL
		out	(c),l
		ld	bc,GYOffsH
		out	(c),h


impr2		ld	bc,VSINTL
		out	(c),l
		ld	bc,VSINTH
		out	(c),h

		ld	hl,size_count
		dec	(hl)
		ld	a,(size_count)
		cp	0
		jr	nz,impr3
		call	flip_color
		ld	a,(line_size)
		ld	(size_count),a

		

impr3		pop	bc
		pop	de
		pop	hl
		pop	af
		ei
		RET

size_count	defb	1
int_line	defw	0


;----------------------------------------------------------
;   -  1    
;  ,   
;----------------------------------------------------------                     
im_proc_1	di
		push	af
		push	hl
		push	de
		push	bc
		
		call	line_change
		call	set_color
		
		call	music+5

		ld	a,(line_size)
		ld	(size_count),a

		ld	d,0
		ld	e,a
		ld	hl,90
		sbc	hl,de
		ld	bc,GXOffsL
		out	(c),l
		ld	bc,GXOffsH
		out	(c),h	

		ld	hl,im_proc_2	;   2  .
		ld	(#beff),hl

		ld	hl,32-1		;  1  (32 - 1  )
		ld	bc,VSINTL
		out	(c),l
		ld	bc,VSINTH
		out	(c),h
		ld	(int_line),hl

		pop	bc
		pop	de
		pop	hl
		pop	af
		ei
		ret

;-------------------------------------------------
;   
;------------------------------------------------- 

set_im2		ld	a,#be
		ld	i,a
		ld	hl,im_proc_1
		ld	(#beff),hl
		
		ld	bc,HSINT
		ld	a,0
		out	(c),a

		ld	hl,0
		ld	bc,VSINTL
		out	(c),l
		ld	bc,VSINTH
		out	(c),h

		im	2
		ret

;--------------------------------------------

line_change	ld	a,(line_dir)
		cp	0
		jr	z,line_u

line_d		ld	hl,line_size
		dec	(hl)
		ld	a,(hl)
		cp	1
		jr	nz,line_l1
		ld	a,0
		ld	(line_dir),a

line_u		ld	hl,line_size
		inc	(hl)
		ld	a,(hl)
		cp	90
		jr	nz,line_l1
		ld	a,1
		ld	(line_dir),a
line_l1		ret


line_size	defb	4
line_dir	defb	0
;------------------------------------------------------------------------
;        ( )
;------------------------------------------------------------------------
create_screen	call	create_1_line
		ld	a,(cel_size)
		inc	a
		cp	128
		ret	z
		ld	(cel_size),a
		
		ld	a,(curr_line)
		inc	a
		ld	(curr_line),a
		cp	64
		jr	nz,crs1
		ld	a,0
		ld	(curr_line),a
		ld	a,(curr_page)
		inc	a
		ld	(curr_page),a
		ld	hl,#C000
		ld	(line_addr),hl
		ld	bc,Page3
		out	(c),a
		jr	create_screen
crs1		ld	hl,(line_addr)
		inc	h
		ld	(line_addr),hl
		jr	create_screen

create_1_line	ld	hl,(line_addr)
		ld	de,512
		ld	a,2
		ld	(pix_count),a
		ld	a,%00010000
		ld	(pix_mask),a

crl20		ld	a,(cel_size)
		ld	b,a
		
crl21		call	set1pixel
		dec	de
		ld	a,d
		or	e
		ret	z
		djnz	crl21

		ld	a,(cel_size)
		ld	b,a
crl22		call	set0pixel
		dec	de
		ld	a,d
		or	e
		ret	z
		djnz	crl22
		jp	crl20
crl_end		ret

set1pixel	ld	a,(pix_mask)
		ld	c,a
		ld	a,(hl)
		or	c
		ld	(hl),a

		ld	a,(pix_mask)
		rrc	a
		rrc	a
		rrc	a
		rrc	a
		ld	(pix_mask),a		
		
		ld	a,(pix_count)
		dec	a
		or	a
		jr	nz,setl1
		inc	hl
		ld	a,2
setl1		ld	(pix_count),a	
		ret

set0pixel	ld	a,(pix_mask)
		rrc	a
		rrc	a
		rrc	a
		rrc	a
		ld	(pix_mask),a		
		
		ld	a,(pix_count)
		dec	a
		or	a
		jr	nz,setl2
		inc	hl
		ld	a,2
setl2		ld	(pix_count),a	
		ret	

pix_mask	defb	%00010000
pix_count	defb	2


line_addr	defw	#c100
curr_page	defb	128
curr_line	defb	1
cel_size	defb	1				
			
;---------------------------------------------------------------------------
;                         init default palette   
;---------------------------------------------------------------------------
init_pal	ld  a,%00010000   ;   #0000
           	ld  bc,FMAddr
           	out (c),a
		ld	hl,zx_palette
		ld	de,512-32
		ld	bc,32
		ldir
		xor	a            	;  
        	ld	bc,FMAddr
          	out	(c),a
		ret
zx_palette	include	"dev\zx_palette.asm"
;---------------------------------------------------------------------------
;    0    .  .
;---------------------------------------------------------------------------
set_color	ld  a,%00010000   ;   #0000
           	ld  bc,FMAddr
           	OUT (c),a

		ld	hl,#0000
		ld	de,#6318
		ld	(color1),hl
		ld	(#0000),hl
		ld	(color2),de
		ld	(#0002),de

		xor	a            	;  
        	ld	bc,FMAddr
          	out	(c),a
		ret
;-----------------------------------------------------------------
;                               
;-----------------------------------------------------------------
flip_color	ld  a,%00010000   ;   #0000
           	ld  bc,FMAddr
           	OUT (c),a

		ld	hl,(color1)
		ld	de,(color2)
		ld	(color1),de
		ld	(color2),hl
		ld	hl,(color1)
		ld	(#0000),hl
		ld	hl,(color2)
		ld	(#0002),hl


		xor	a            	;  
        	ld	bc,FMAddr
          	out	(c),a
		ret	

color1		defw	0
color2		defw	0


;----------------------------------------------
;    
;     
;----------------------------------------------
fill_tile_0	ld	ix,49152
		jr	fill_tile

fill_tile_1	ld	ix,49152+128

fill_tile	ld	bc,Page3
		ld	a,150
		out	(c),a
		
		ld	de,64
		ld	hl,0
		ld	b,64

fill_l1		push	bc
		push	ix
		push	hl

		ld	b,64
fill_l2		ld	(ix+0),l
		ld	a,h
		and	%00001111
		or	%00110000
		ld	h,a
		ld	(ix+1),h
		inc	hl
		inc	ix
		inc	ix
		djnz	fill_l2
		pop	hl
		add	hl,de
		pop	ix
		add	ix,de
		add	ix,de
		add	ix,de
		add	ix,de

		pop	bc
		djnz	fill_l1
		ret

;--------------------------------------------------------
;      ()
;--------------------------------------------------------

bit_copy	ld	bc,DMASAddrX
		ld	a,50		
		out	(c),a
		ld	hl,0
		ld	bc,DMASAddrH
		out	(c),h
		ld	bc,DMASAddrL
		out	(c),l
	
		ld	bc,DMADAddrX
		ld	a,160		
		out	(c),a
		ld	hl,0
		ld	bc,DMADAddrH
		out	(c),h
		ld	bc,DMADAddrL
		out	(c),l
	
		ld	bc,DMALen
		ld	a,89
		out	(c),a
	
		ld	bc,DMANum
		ld	a,255
		out	(c),a
	
		ld	bc,DMACtrl
		ld	a,%00010001
		out	(c),a
		
		ld	bc,DMAStatus
bc1l		in	a,(c)
		or	a
		jr	nz,bc1l

		ld	bc,DMASAddrX
		ld	a,52		
		out	(c),a
		ld	hl,13312
		ld	bc,DMASAddrH
		out	(c),h
		ld	bc,DMASAddrL
		out	(c),l
	
		ld	bc,DMADAddrX
		ld	a,164		
		out	(c),a
		ld	hl,0
		ld	bc,DMADAddrH
		out	(c),h
		ld	bc,DMADAddrL
		out	(c),l
	
		ld	bc,DMALen
		ld	a,89
		out	(c),a
	
		ld	bc,DMANum
		ld	a,31
		out	(c),a
	
		ld	bc,DMACtrl
		ld	a,%00010001
		out	(c),a
		
		ld	bc,DMAStatus
bc2l		in	a,(c)
		or	a
		jr	nz,bc2l
		ret

clear_page	ld	bc,Page0
		ld	a,33
		out	(c),a
		ld	hl,0
		ld	(0),hl


		ld	bc,DMASAddrX
		ld	a,33		
		out	(c),a
		ld	hl,0
		ld	bc,DMASAddrH
		out	(c),h
		ld	bc,DMASAddrL
		out	(c),l
	
		ld	bc,DMADAddrX
		ld	a,128		
		out	(c),a
		ld	hl,0
		ld	bc,DMADAddrH
		out	(c),h
		ld	bc,DMADAddrL
		out	(c),l
	
		ld	bc,DMALen
		ld	a,255
		out	(c),a
	
		ld	bc,DMANum
		ld	a,64
		out	(c),a
	
		ld	bc,DMACtrl
		ld	a,%00000100
		out	(c),a
		
		ld	bc,DMAStatus
c1rl		in	a,(c)
		or	a
		jr	nz,c1rl


music		include "dev\PTxPlay.asm"
		incbin	"dev\popcorn.pt3"

endcode		nop
				

	
	SAVEBIN "1-spg\zapili.bin",start, endcode-start


